/* 
 * ASCD : copyright (c) Aley Keprt 1998-2001
 * SimCoupe : Copyright (c) Allan Skillman 1996.
 *
 * File samgrx.c : SAM display driver routines - DOS vga version
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifdef __cplusplus
extern "C" {
#endif


extern int ClutChangeInLine;
extern int BorderChangeInLine;
extern int VmprChangeInLine;
extern int BorderChangeInLine;
#ifdef USE_BORDER_EFFECTS
extern int BorderChangeInInstruction;
#endif



void init_ports(void);
void out_byte(uns16 port, uns8 val);
uns8 in_byte(uns16 port);

void out_vmpr(uns8 val);   //needed to restore screen after closing user itnerface
inline void out_hmpr(uns8 val); //needed in tape-emulation


#define SOUND_ADDR      511
#define SOUND_DATA      255

#define VMPR_PORT       252
#define HMPR_PORT       251
#define LMPR_PORT       250
#define MIDI_PORT       253
#define BORDER_PORT     254
#define LINE_PORT       249
#define CLUT_BASE_PORT  248
#define ATTR_PORT       255
#define KEYBOARD_PORT   254
#define STATUS_PORT     249
#define LPEN_PORT       248
#define HPEN_PORT       504
#define CLOCK_PORT      239

#define LEPR_PORT       128
#define HEPR_PORT       129

#define DISK1_PORT      224
#define DISK2_PORT      240

#define PRINTL1_DATA    232
#define PRINTL1_STAT    233

#define PRINTL2_DATA    234
#define PRINTL2_STAT    235

#define VMPR_SCREEN_PAGE        (vmpr & 0x1f)
#define VMPR_SCREEN_MODE        (vmpr & 0x60)
#define HMPR_PAGE               (hmpr & 0x1f)
#define HMPR_MD3COL            ((hmpr & 0x60) >> 3)
#define HMPR_MCNTRL             (hmpr & 0x80)
#define LMPR_PAGE               (lmpr & 0x1f)
#define LMPR_RAM0               (lmpr & 0x20)
#define LMPR_ROM1               (lmpr & 0x40)
#define LMPR_WPRAM              (lmpr & 0x80)

#define BORD_VAL(x)            ((((x) & 0x20 ) >> 2) | ((x) & 0x07))
#define BORD_COL(x)            ((x) & 0x27)
#define BORD_SOFF               (border & 0x80)

#define MODE_1                  0x00
#define MODE_2                  0x20
#define MODE_3                  0x40
#define MODE_4                  0x60

/* The sam ports */

/* read/write ports */
extern int vmpr,hmpr,lmpr;
extern int midi;
extern int border;
extern uns8 clut[];
extern int keyboard;
extern int status_reg;
extern int line_int;
extern int clock_reg;
extern int lepr,hepr;
extern int attr_reg;
extern int beeperbit;
extern int kjport;
extern int fuller;


#ifdef __cplusplus
}
#endif

